<?php

namespace Drupal\render_profiler;

class Tracer {

  protected static $count = 0;

  protected static $depth = 0;

  protected static $trace = [];

  /**
   * @return int
   */
  public static function getCount(): int {
    return self::$count;
  }

  /**
   * @return int
   */
  public static function getDepth(): int {
    return self::$depth;
  }

  /**
   * @return array
   */
  public static function getTrace(): array {
    return self::$trace;
  }

  /**
   * @return int
   */
  public static function incrementCount(): int {
    self::$count++;
    return self::$count;
  }

  /**
   * @return int
   */
  public static function descend(): int {
    self::$depth++;
    self::$trace[] = self::getCount();
    return self::$depth;
  }

  /**
   * @return int
   */
  public static function ascend(): int {
    self::$depth--;
    array_pop(self::$trace);
    return self::$depth;
  }

}
